/**
 * BasicMapping.as
 * 
 * Copyright (c) 2008 Tom Beddard
 * http://www.subblue.com
 * 
 * Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
 */


package com.subblue.fractal.mappings
{
    import com.subblue.fractal.Mapping;
	import com.subblue.fractal.ColorPalette;
	import com.subblue.utils.ColorUtil;

    public class BasicMapping extends Mapping
    {
		/**
		 *	Create a linear mapping
		 */
		public function BasicMapping(palette:Array = null, size:int = 0)
        {
			super(palette, size);
        }
		
		
		/**
		 *	Return the colour value for the required index.
		 *	This is the linear transfer
		 *	
		 *	@param		re		Real component
		 *	@param		im		Imaginary component
		 *	@param		n		Number of iterations taken
		 */
		override public function map(re:Number, im:Number, zz:Number, n:int):uint
		{
			return color(n);
		}
		
		
	 	/**
		 *  Returns an exact copy of the object
		 */
		public function clone():BasicMapping
		{
			return (new BasicMapping(_palette, _size));
		}
		
		
		/**
		 * Returns a representation of the object as a string
		 */
		override public function toString():String {
			return "BasicMapping";
		}
    }
}
