/**
 * BinaryDecomposition1.as
 * 
 * Copyright (c) 2008 Tom Beddard
 * http://www.subblue.com
 * 
 * Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
 */


package com.subblue.fractal.mappings
{
    import com.subblue.fractal.Mapping;

    public class BinaryDecomposition1 extends Mapping
    {
		
		/**
		 *	Create a linear mapping
		 */
		public function BinaryDecomposition1(palette:Array = null, size:int = 0)
        {
			super(palette, size);
        }
		
		
		/**
		 *	Binary Decomposition 1
		 *	
		 *	@param		re		Real component
		 *	@param		im		Imaginary component
		 *	@param		n		Number of iterations taken
		 */
		override public function map(re:Number, im:Number, zz:Number, n:int):uint
		{
			return Math.atan2(im, re) > 0 ? 0xFFFFFFFF : 0xFF000000;
		}
		
		
	 	/**
		 *  Returns an exact copy of the object
		 */
		public function clone():BinaryDecomposition1
		{
			return (new BinaryDecomposition1(_palette, _size));
		}
		
		/**
		 * Returns a representation of the object as a string
		 * @return A representation of the object as a string
		 */
		override public function toString():String {
			return "BinaryDecomposition";
		}
    }
}
